
#ifndef FORMULA_H_
#define FORMULA_H_

#include "common.h"

using namespace std;

typedef set<int> Pt_Collection;

class CFormulaNode {
public:
	int count;
	bool isComplement;
	int range;
	Pt_Collection* set;
	bool shared;
	static int cnt;

	CFormulaNode() {
		CFormulaNode::cnt++;
		shared = false;
		isComplement = false;
		range = 0;
		count = 0;
		set = NULL;
	}

	CFormulaNode(CFormulaNode& c) {
		CFormulaNode::cnt++;
		isComplement = c.isComplement;
		range = c.range;
		count = c.count;

		if (set != NULL)
			delete set;

		set = new Pt_Collection(*c.set);
	}
	void attach(CFormulaNode& c) {
		isComplement = c.isComplement;
		range = c.range;
		count = c.count;
		set = c.set;
		shared = true;
		if (set == NULL) {
			//::errlog("1");
			printf("asdf");
		}
	}

	bool isfull() {
		if (size() == range)
			return true;
		return false;
	}

	void copy(CFormulaNode& c) {
		isComplement = c.isComplement;
		range = c.range;
		count = c.count;

		if (set != NULL)
			delete set;

		set = new Pt_Collection(*c.set);
		//shared = true;
		if (set == NULL) {
			//::errlog("1");
			printf("asdf");
		}
	}

	~CFormulaNode() {
		CFormulaNode::cnt--;
		if (set != NULL) {
			set->clear();
			delete set;
		}
	}

	void show() {
		if (isComplement) {
			printf("\nit is complement \n");
		} else {
			printf("\nit is not complement \n");
		}

		printf("range is %d \n", range);
		//printf("set contains %d\n", set->size());

		if (set != NULL) {
			printf("\n set contains packages points %d:\n", set->size());
			std::set<int>::iterator j;
			for (j = set->begin(); j != set->end(); ++j) {
				printf("%d ", *j);
			}
		} else {
			//::errlog("null");
		}

	}

	int size() {
		if (isComplement) {
			return range - set->size();
		} else {
			return set->size();
		}
	}

	long countnode() {
		long size = 0;
		size += sizeof(int);
		size += sizeof(bool);
		size += sizeof(int);
		if (set != NULL) {
			size += sizeof(*set) * set->size();
		}

		return size;
	}
	//CFormulaNode& operator =(CFormulaNode& cf);
};

class CSetformula {
public:
	list<CFormulaNode*> formula;
	int dim;

	static int cnt;

	CSetformula() {
		CSetformula::cnt++;
	}

	CSetformula(CSetformula &ct) {
		CSetformula::cnt++;
		dim = ct.dim;
		list<CFormulaNode*>::iterator i;
		for (i = ct.formula.begin(); i != ct.formula.end(); i++) {
			CFormulaNode* tp = new CFormulaNode[dim];
			for (int j = 0; j < dim; j++) {
				Pt_Collection* pt = new Pt_Collection;
				if ((*i)[j].set == NULL) {
					printf("1");
				} else if (pt == NULL) {
					printf("2");
				}
				::copy((*i)[j].set->begin(), (*i)[j].set->end(), ::inserter(
						*pt, pt->begin()));

				tp[j].set = pt;
				tp[j].range = (*i)[j].range;
				tp[j].isComplement = (*i)[j].isComplement;

			}
			formula.push_back(tp);
		}
	}
	~CSetformula() {
		CSetformula::cnt--;
		list<CFormulaNode*>::iterator i;
		for (i = formula.begin(); i != formula.end(); i++) {
			CFormulaNode* node = *i;
			delete[] node;
		}
		//delete formula;
	}
	void init(int n, int p, CFormulaNode** matrix);
	void show();

	int size();

	long count() {
		long size = 0;
		size += sizeof(int);
		//size += 2*sizeof(void*)*formula.size();

		list<CFormulaNode*>::iterator i;
		for (i = formula.begin(); i != formula.end(); i++) {
			for (int j = 0; j < dim; j++) {
				size += sizeof(formula);
				size += (*i)[j].countnode();
			}
		}
		return size;
	}
	;
};

#endif
